From 161ec3cc65e65b6ff3728b837eda288667868074 Mon Sep 17 00:00:00 2001
From: Ryan Hsu <ryanhsu@codeaurora.org>
Date: Mon, 6 Jul 2015 18:20:22 -0700
Subject: [PATCH] cfg80211: Bypass checkin the CHAN_RADAR if DFS_OFFLOAD is
 enabled

When WIPHY_FLAG_DFS_OFFLOAD is defined, driver would take care the
DFS related operation, hence the kernel needs to ignore the DFS
states checking.

CRs-fixed: 1080548
Change-Id: I02fa5e3e25427c0ca474455fa2d2be9eb6ea4bd9
Signed-off-by: Ryan Hsu <ryanhsu@codeaurora.org>
---
 net/wireless/chan.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

diff --git a/net/wireless/chan.c b/net/wireless/chan.c
index 9175073..bb1362e 100644
--- a/net/wireless/chan.c
+++ b/net/wireless/chan.c
@@ -596,10 +596,12 @@ static bool cfg80211_secondary_chans_ok(struct wiphy *wiphy,
 
 		if (!c)
 			return false;
-		/* check for radar flags */
+
 		if ((!(wiphy->flags & WIPHY_FLAG_DFS_OFFLOAD)) &&
-		    (prohibited_flags & c->flags & IEEE80211_CHAN_RADAR) &&
-		    (c->dfs_state != NL80211_DFS_AVAILABLE))
+		    (c->flags & prohibited_flags & IEEE80211_CHAN_RADAR))
+			return false;
+
+		if (c->flags & prohibited_flags & ~IEEE80211_CHAN_RADAR)
 			return false;
 	}
 	return true;
-- 
2.7.4

